	/*
	Appello del 10.07.2018 - Esercizio 2 
	Scrivere un metodo parametrico statico isMax che accetta un oggetto x,
	un comparatore ed una lista di oggetti, e restituisce true se, in base al
	comparatore, x  maggiore ("segue") o uguale di tutti gli oggetti
	contenuti nella lista.
	Altrimenti, il metodo restituisce false.
	Porre particolare attenzione alla scelta della firma.
	*/
	import java.util.*;

	public class IsMax {
		
		public static <T> boolean isMax(T x, Comparator<T> c, List<T> lista) {
			boolean flag = true;
			for (T i: lista) {
				if (c.compare(x,i) < 0) {flag= false; break;}
			}
			return flag;
		} //end-isMax

// fine esercizio esame

// Esercitazione: codice di TEST
		
		public static class Integer_incr implements Comparator<Integer> {

			  public int compare (Integer s1, Integer s2) { 
				  return s1.compareTo(s2);
			  }
		}
		
		public static class Integer_decr implements Comparator<Integer> {

			  public int compare (Integer s1, Integer s2) { 
				  return -s1.compareTo(s2);
			  }
		}
		
		private static void StampaFlag (boolean flag) {
			if (flag) System.out.print("segue ");
			else System.out.print("precede ");
			System.out.println("tutti gli interi della lista");
		}
		
		public static void main(String[] args)  
		{
			LinkedList<Integer> lista = new LinkedList<Integer>();
			Integer x;
			boolean flag;
			Random random = new Random();
			// genera e stampa lista casuale di 10 interi in [0,99]
			for (int i=0; i<10; i++)  lista.add(random.nextInt(100));
			System.out.println(lista);
			// genera intero random in [0,99]
			x = random.nextInt(100);
			
			flag = isMax(x-100, new IsMax.Integer_incr(), lista);
			// stampa necessariamente precede 
			System.out.println("\nSecondo un ordinamento crescente l'intero " + (x-100));
			StampaFlag(flag);
			
			flag = isMax(x-100, new Integer_decr(), lista);
			// stampa necessariamente segue 
			System.out.println("\nSecondo un ordinamento decrescente l'intero " + (x-100));
			StampaFlag(flag);
			
			flag = isMax(x+100, new IsMax.Integer_incr(), lista);
			// stampa necessariamente precede 
			System.out.println("\nSecondo un ordinamento crescente l'intero " + (x+100));
			StampaFlag(flag);
			
			flag = isMax(x+100, new IsMax.Integer_decr(), lista);
			// stampa necessariamente precede 
			System.out.println("\nSecondo un ordinamento decrescente l'intero " + (x+100));
			StampaFlag(flag);
			
		
		}//end-main
					


		
}
