import java.util.*;

public class Book implements Comparable<Book>{
	ArrayList<String> authors = new ArrayList<String>();
	String	title, ISBN; 
	
public Book(String newIsbn) {
		title = "";
		ISBN = newIsbn;
}


public Book(ArrayList<String> newAuthors, String newTitle, String newIsbn) {
	authors = newAuthors;
	title = newTitle;
	ISBN = newIsbn;
}

public Book(String newAuthor, String newTitle, String newIsbn) {
	authors.add(newAuthor);
	title = newTitle;
	ISBN = newIsbn;
}


public ArrayList<String> getAuthors() {return authors;}
public String getTitle() {return title;}
public String getISBN() {return ISBN;}

public void setAuthors(ArrayList<String> newAuthors) {authors = newAuthors;}
public void setAuthor(String newAuthor) {authors.add(newAuthor);}

public void setTitle(String newTitle) {title = newTitle;}
public void setISBN(String newIsbn) {ISBN = newIsbn;}  //opportuno ?


@Override 
public String toString(){
	return ("ISBN:" + ISBN + " - "  + title + " - by " + authors );
}

@Override 
public boolean equals(Object obj){
	if (obj == null) return false;
     if (!(obj instanceof Book)) return false;
     Book p = (Book) obj; 
//     return ISBN.contentEquals(p.ISBN);
     return ISBN.equals(p.ISBN);

}

public boolean equals(String isbn){
	Book OtherBook = new Book(isbn);	
	return this.equals(OtherBook);
}

@Override    
public int compareTo(Book altro){
	return ISBN.compareTo(altro.ISBN);
}



} //end-class

