import java.util.*;

/**
 * Scrivere un metodo generico che, data una lista, restituisce lelemento pi piccolo contenuto in essa.
 * Write a generic method which accepts a list and returns the smallest item.
 * 
**/

public class Ex2a {		
		public static <T extends Comparable<? super T>> T MinItem( List<T> list ) {
			if (list.isEmpty()) return null;
			T minItem = list.get(0);
			for (T x: list) if ( x.compareTo(minItem) < 0 ) minItem = x;
			return minItem;
	}
		
	
	public static void main(String[] args) {
		List<String> list = new LinkedList<String>();
		list.add("Exam");
		list.add("Algorithm");
		list.add("Laboratory");
		list.add("Class");
		System.out.println("Lista: " + list);
		String s = Ex2a.<String>MinItem(list);
		System.out.println("Stringa minima: " + s);
	} //main


}