import java.util.*;

/**
 * Write a generic method which accepts a list of objects and sorts the
 * specified list into decreasing order, according to the natural ordering
 * of its elements.
**/

class Decreasing<T extends Comparable<? super T>>  implements Comparator<T>{
	public int compare(T obj1, T obj2) {
		return - obj1.compareTo(obj2);
	}			
} //end-class


public class Ex2b {		
		public static <T extends Comparable<? super T>> void MySort( List<T> list ) {
		Collections.sort(list, new Decreasing<T>());
	}
		
	
	public static void main(String[] args) {
		List<String> list = new LinkedList<String>();
		list.add("Exam");
		list.add("Algorithm");
		list.add("Laboratory");
		list.add("Class");
		System.out.println("Lista: " + list);
		Ex2b.<String>MySort(list);
		System.out.println("Stringa ordinata in modo decrescente:\n" + list);
	} //main


}


