import java.util.*;

public class Contatto implements Comparable<Contatto> {
	String	nome, cognome;
	ArrayList<String> elencoNumeri = new ArrayList<String>();
 
public Contatto(String newNome, String newCognome, String newNum) {
		nome = newNome;
		cognome = newCognome;
		elencoNumeri.add(newNum);
}

public Contatto(String newNome, String newCognome, ArrayList<String> newElencoNum) {
	nome = newNome;
	cognome = newCognome;
	elencoNumeri=newElencoNum;
}

public String getNome() {return nome;}
public String getCognome() {return cognome;}
public ArrayList<String> getNumeri() {return elencoNumeri;}

public void setElenco(ArrayList<String> newElenco) {elencoNumeri = newElenco;}
public void setNome(String newNome) {nome = newNome;}
public void setCognome(String newCognome) {cognome = newCognome;}  
public boolean addNumero(String newNum) {
	if (!elencoNumeri.contains(newNum)) return elencoNumeri.add(newNum);
	else return false; 
}

@Override 
public String toString(){
	return (nome + " " + cognome + ": "  + elencoNumeri );
}

@Override 
public boolean equals(Object obj){
	if (obj == null) return false;
     if (!(obj instanceof Contatto)) return false;
     Contatto c = (Contatto) obj; 
     return nome.equalsIgnoreCase(c.nome) && cognome.equalsIgnoreCase(c.cognome);
}

@Override    
public int compareTo(Contatto altro){
	int compareNome = nome.compareToIgnoreCase(altro.nome);
	if (compareNome==0) return cognome.compareToIgnoreCase(altro.cognome);
	else return compareNome;
}



} //end-class

